package edu.uoc.petfinder.configuration;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;
import io.micrometer.core.instrument.util.DoubleFormat;
import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;
import lombok.RequiredArgsConstructor;
import org.springframework.data.geo.Distance;

import java.io.IOException;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.text.NumberFormat;

public class DistanceSerializer extends StdSerializer<Distance> {


    protected DistanceSerializer(Class<Distance> t) {
        super(t);
    }

    @Override
    public void serialize(Distance value, JsonGenerator gen, SerializerProvider provider) throws IOException {
        gen.writeStartObject();
        gen.writeNumberField("value", value.getValue());
        gen.writeStringField("unit", value.getUnit());
        gen.writeEndObject();
    }
}
