package edu.uoc.petfinder.controller;

import edu.uoc.petfinder.dto.ImageDto;
import edu.uoc.petfinder.service.ImageService;
import lombok.AllArgsConstructor;
import org.apache.commons.io.IOUtils;
import org.springframework.core.io.Resource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;

@RestController
@RequestMapping("/image")
@AllArgsConstructor
public class ImageController {

    private ImageService imageService;

    @GetMapping("/{systemFileName:.+}")
    @ResponseBody
    public ResponseEntity retrieveImageResponseEntity(@PathVariable String systemFileName) throws IOException {
        ImageDto imageDto = this.imageService.fetchImage(systemFileName, Boolean.TRUE);
        HttpHeaders headers = new HttpHeaders();
        Resource resource = imageDto.getFileResource();
        byte[] bytes = IOUtils.toByteArray(resource.getInputStream());
        headers.setContentType(MediaType.parseMediaType(imageDto.getContentType()));
        return new ResponseEntity<>(bytes, headers, HttpStatus.OK);
    }

}
