package edu.uoc.petfinder.exception;

import lombok.Data;
import org.springframework.http.HttpStatus;

@Data
public class PetFinderException extends RuntimeException {

    private String message;
    private String details;
    private HttpStatus status;
    private String code;

    public PetFinderException(String message, String details, HttpStatus status, String code) {
        super(message);
        this.message = message;
        this.details = details;
        this.status = status;
        this.code = code;
    }

    public PetFinderException(String message, HttpStatus status) {
        super(message);
        this.message = message;
        this.status = status;
    }



    public PetFinderException(String message, Throwable cause, HttpStatus status, String code) {
        super(message, cause);
        this.message = message;
        this.status = status;
        this.code = code;
    }
}
