package edu.uoc.petfinder.mapper;

import edu.uoc.petfinder.dto.*;
import edu.uoc.petfinder.model.*;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Named;

import java.util.Arrays;

@Mapper
public interface ApiMapper {

    User userDtoToUser(UserDto userDto);

    UserDto userToUserDto(User user);

    Role roleDtoToRole(RoleDto roleDto);

    RoleDto roleToRoleDto(Role role);

    Pet petDtoToPet(PetDto petDto);

    PetDto petToPetDto(Pet pet);

    Action actionDtoToAction(ActionDto actionDto);

    ActionDto actionToActionDto(Action action);

    Image imageDtoToImage(ImageDto imageDto);

    ImageDto imageToImageDto(Image image);

    SimplePetDto petToSimplePetDto(Pet pet);

    SimpleActionDto actionToSimpleActionDto(Action action);

    default Location locationDtoToLocation(LocationDto locationDto) {
        if (locationDto == null) {
            return null;
        }
        return new Location(new Double[] {locationDto.getLongitude(), locationDto.getLatitude()});
    }

    default LocationDto locationToLocationDto(Location location) {
        if (location == null) {
            return null;
        }
        return LocationDto.builder()
                .longitude(location.getCoordinates()[0])
                .latitude(location.getCoordinates()[1])
                .build();
    }

}
