package edu.uoc.petfinder.model;

import lombok.Data;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.Document;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.InputStream;

@Document(collection = "IMAGES")
@Data
public class Image {

    @Id
    private String id;

    @NotEmpty
    private String originalFileName;

    @Indexed(unique = true)
    private String systemFileName;

    @NotEmpty
    private String contentType;

    @NotNull
    private Long contentLength;

}
