package edu.uoc.petfinder.model;

import lombok.Data;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.DBRef;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;

import javax.validation.constraints.Email;
import javax.validation.constraints.NotEmpty;
import java.time.ZonedDateTime;
import java.util.HashSet;
import java.util.Set;


@Data
@Document(collection = "USERS")
public class User {

    @Id
    private String id;

    private String firstName;

    private String lastName;

    @NotEmpty
    @Email
    @Indexed(unique = true)
    private String email;

    @NotEmpty
    private String password;

    private ZonedDateTime birthDate;

    private Boolean isSocial;

    @DBRef
    private Set<Role> roles = new HashSet<>();

}
