package edu.uoc.petfinder.service;

import edu.uoc.petfinder.dto.PetDto;
import edu.uoc.petfinder.dto.SimplePetDto;
import edu.uoc.petfinder.dto.UserDto;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import org.springframework.transaction.annotation.Transactional;

public interface PetService {
    @Transactional
    PetDto createPet(PetDto petDto, String userEmail);

    PetDto updatePet(PetDto petDto, String userEmail);

    PetDto getPetById(String petId);

    PetDto getPetByIdAndOwner(String petId, UserDto owner);

    PetDto mergeAndUpdatePet(PetDto previousPetDto, PetDto petToUpdate, UserDto userDto);

    Page<SimplePetDto> findAllPetsOrderedByDateDesc(Pageable pageable);

    Page<SimplePetDto> findFoundPetsOrderedByDateDesc(Pageable pageable);

    Page<SimplePetDto> searchPets(String search, Pageable pageable);

    void deletePet(String petId, Boolean isOwnPet, UserDto userDto);
}
