package edu.uoc.petfinder.service;

import edu.uoc.petfinder.dto.SimplePetDto;
import edu.uoc.petfinder.dto.UserDto;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;

public interface UserService {
    @Transactional
    UserDto createUser(UserDto userDto);

    Boolean isEmailAvailable(String email);

    UserDto getUserByEmail(String email);

    UserDto patchUserFields(UserDto connectedUser, UserDto updatedUserDto);

    Page<SimplePetDto> fetchPaginatedPetsByUser(UserDto connectedUser, Pageable pageable);

    Page<UserDto> searchUsers(String search, Pageable pageable);

    void deleteUser(String userId);
}
