package edu.uoc.petfinder.state;

import edu.uoc.petfinder.constant.ActionType;
import edu.uoc.petfinder.dto.PetDto;
import edu.uoc.petfinder.exception.PetFinderException;
import edu.uoc.petfinder.service.ActionService;
import edu.uoc.petfinder.service.PetService;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Component;

@Component
public class SightingState extends State {

    public SightingState(ActionService actionService) {
        super(actionService);
    }

    @Override
    public PetDto lost(ActionContext context) {
        throw new UnsupportedOperationException("Error: Operation not supported");
    }

    @Override
    public PetDto sighting(ActionContext context) {
        PetDto petDto = context.getPetDto();
        if (petDto.getLastState() == null || petDto.getLastState().getType().equals(ActionType.FOUND)) {
            throw new PetFinderException("Error: last state is empty or found", HttpStatus.NOT_ACCEPTABLE);
        }
        return super.addActionToPet(context, petDto);
    }

    @Override
    public PetDto found(ActionContext context) {
        throw new UnsupportedOperationException("Error: Operation not supported");
    }
}
