package edu.uoc.petfinder.state;

import edu.uoc.petfinder.dto.ActionDto;
import edu.uoc.petfinder.dto.PetDto;
import edu.uoc.petfinder.service.ActionService;
import edu.uoc.petfinder.service.PetService;
import lombok.AllArgsConstructor;
import org.springframework.util.StringUtils;

import java.time.Instant;
import java.util.Optional;

@AllArgsConstructor
public abstract class State {

    protected ActionService actionService;

    public abstract PetDto lost(ActionContext context);

    public abstract PetDto sighting(ActionContext context);

    public abstract PetDto found(ActionContext context);

    protected PetDto addActionToPet(ActionContext context, PetDto petDto) {
        ActionDto actionDto = context.getActionDto();
        this.checkPresetActionInList(petDto);
        actionDto.setCreator(context.getUserDto());
        actionDto = this.actionService.saveAction(actionDto);
        petDto.addAction(actionDto);
        petDto.setLastState(actionDto);
        return petDto;
    }

    private void checkPresetActionInList(PetDto petDto) {
        Optional<ActionDto> actionOpt = petDto.getActions().stream().filter(action -> StringUtils.isEmpty(action.getId())).findFirst();
        if (actionOpt.isPresent()) {
            petDto.getActions().remove(actionOpt.get());
        }
    }
}
