package edu.uoc.petfinder.state;

import edu.uoc.petfinder.dto.ActionDto;
import edu.uoc.petfinder.exception.PetFinderException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Component;

@Component
public class StateFactory {

    @Autowired
    private ApplicationContext applicationContext;

    public State getState(ActionDto actionDto){
        if (actionDto.getType() == null) {
            throw new PetFinderException("Error fetching state from actionType: Empty action type", HttpStatus.BAD_REQUEST);
        }
        switch (actionDto.getType()) {
            case LOST:
                return (State) this.applicationContext.getBean("lostState");
            case FOUND:
                return (State) this.applicationContext.getBean("foundState");
            case SIGHTING:
                return (State) this.applicationContext.getBean("sightingState");
            default:
                throw new PetFinderException("Error: Unrecognized state", HttpStatus.BAD_REQUEST);
        }
    }
}
