package edu.uoc.petfinder.controller;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.jlefebure.spring.boot.minio.MinioService;
import edu.uoc.petfinder.dto.UserDto;
import edu.uoc.petfinder.security.JwtTokenFilter;
import edu.uoc.petfinder.service.UserService;
import io.minio.MinioClient;
import org.junit.jupiter.api.BeforeEach;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.json.AutoConfigureJsonTesters;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.autoconfigure.web.servlet.WebMvcTest;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.boot.test.mock.mockito.SpyBean;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.web.servlet.MockMvc;

import static org.mockito.ArgumentMatchers.anyString;
import static org.mockito.Mockito.when;

@AutoConfigureJsonTesters
@SpringBootTest
@AutoConfigureMockMvc
@ActiveProfiles("test")
public abstract class   BaseControllerTest {

    @Autowired
    protected MockMvc mockMvc;

    @Autowired
    protected ObjectMapper objectMapper;

    @MockBean
    protected MinioClient minioClient;

    @MockBean
    protected JavaMailSender javaMailSender;

    protected void mockAuthenticatedUserInjection(UserService userService, String email) {
        UserDto userDto = UserDto.builder().email(email).password("Pass123.").build();
        when(userService.getUserByEmail(anyString())).thenReturn(userDto);
    }



}
