import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { BsModalRef, BsModalService } from 'ngx-bootstrap/modal';
import { BehaviorSubject } from 'rxjs';
import { AccessModalComponent } from './access-modal/access-modal.component';

@Injectable({
  providedIn: 'root'
})
export class AccessModalService {

  private isActiveModalBln = false;

  accessModalRef: BsModalRef;

  constructor(private modalService: BsModalService, private router: Router) {
    this.modalService.onHide.subscribe(() => this.isActiveModalBln = false)
  }

  openAccessModal() {
    this.accessModalRef = this.modalService.show(AccessModalComponent, {/* Initial State to Modal Template */});
    this.isActiveModalBln = true;
  }

  /**
   * Method to use in case of redirect of unauthenticated user
   */
  redirectToAccesModal() {
    this.router.navigate(['/'])
    this.openAccessModal()
  }

  closeAccessModal() {
    if (this.accessModalRef) {
      this.accessModalRef.hide();
      this.accessModalRef = null;
      this.isActiveModalBln = false
    }
  }

  get isActiveModal() {
    return this.isActiveModalBln;
  }
}
