import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { AccessModalComponent } from './access-modal/access-modal.component';
import { LoginFormComponent } from './login-form/login-form.component';
import { RegisterFormComponent } from './register-form/register-form.component';
import { SharedModule } from 'src/app/shared/shared.module';
import { SocialLoginModule, SocialAuthServiceConfig } from 'angularx-social-login';
import {
  GoogleLoginProvider,
  FacebookLoginProvider
} from 'angularx-social-login';
import { PasswordStrengthMeterModule } from 'angular-password-strength-meter';



const socialLoginConfig = {
  provide: 'SocialAuthServiceConfig',
  useValue: {
    autoLogin: false,
    providers: [
      {
        id: GoogleLoginProvider.PROVIDER_ID,
        provider: new GoogleLoginProvider(
          'XXXXXXXXXXX'
        ),
      },
      {
        id: FacebookLoginProvider.PROVIDER_ID,
        provider: new FacebookLoginProvider('XXXXXXXXXXX'),
      }
    ],
  } as SocialAuthServiceConfig,
}


@NgModule({
  declarations: [AccessModalComponent, LoginFormComponent, RegisterFormComponent],
  imports: [
    CommonModule,
    SharedModule,
    SocialLoginModule,
    PasswordStrengthMeterModule
  ],
  providers: [socialLoginConfig],
  exports: [],
  entryComponents:[AccessModalComponent]
})
export class AccessModule { }
