import { Injectable } from '@angular/core';
import { BsModalRef, BsModalService } from 'ngx-bootstrap/modal';
import { ActionType } from 'src/app/models/ActionType';
import Pet from 'src/app/models/Pet';
import { ActionsModalComponent } from './actions-modal/actions-modal.component';
import { ActionsService } from './actions.service';
import { Location } from "../../models/Location";
import { Action } from 'src/app/models/Action';
import { ActionDetailModalComponent } from './action-detail-modal/action-detail-modal.component';

@Injectable({
  providedIn: 'root'
})
export class ActionsModalService {

  actionsModalRef: BsModalRef;
  actionDetailModalRef: BsModalRef;

  constructor(private modalService: BsModalService, private actionsService: ActionsService) { }

  openActionsModal(pet: Pet, action: ActionType, location: Location) {
    this.actionsService.setPetAndAction(pet, action, location);
    this.actionsModalRef = this.modalService.show(ActionsModalComponent);
  }

  openDetailActionModal(action: Action) {
    this.actionsService.setActionToDetail(action);
    this.actionDetailModalRef = this.modalService.show(ActionDetailModalComponent);
  }

  closeActionsModal() {
    if (this.actionsModalRef) {
      this.actionsService.setPetAndAction(null, null, null);
      this.actionsModalRef.hide();
      this.actionsModalRef = null;
    }
  }
}
