import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { ContentRoutingModule } from './content.routing.module';
import { ContentComponent } from './content.component';
import { LayoutModule } from './layout/layout.module';
import { SidebarModule } from 'ng-sidebar';
import { HomeComponent } from './home/home.component';
import { AccessModule } from './access/access.module';
import { SharedModule } from '../shared/shared.module';
import { PetModule } from './pet/pet.module';
import { InfiniteScrollModule } from 'ngx-infinite-scroll';
import { ActionsModule } from './actions/actions.module';

@NgModule({
  declarations: [ContentComponent, HomeComponent],
  imports: [
    CommonModule,
    ContentRoutingModule,
    SidebarModule.forRoot(),
    SharedModule,
    InfiniteScrollModule,
    LayoutModule,
    AccessModule,
    PetModule,
    ActionsModule
  ]
})
export class ContentModule { }
