import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { TranslateService } from '@ngx-translate/core';
import { AuthService } from 'src/app/services/auth.service';
import { UserService } from 'src/app/services/user.service';
import { AccessModalService } from '../../access/access-modal.service';
import { LayoutService } from '../layout.service';

@Component({
  selector: 'app-header',
  templateUrl: './header.component.html',
  styleUrls: ['./header.component.scss']
})
export class HeaderComponent implements OnInit {

  constructor(public layoutService: LayoutService,
    public accessModalService: AccessModalService,
    private router: Router,
    public userService: UserService,
    public translate: TranslateService,
    public authService: AuthService) { }

  ngOnInit(): void {
  }

  toggleSidebar() {
    this.layoutService.toggleSidebar();
  }

  logout() {
    this.authService.logout();
    this.router.navigate(['/']);
  }

  changLang(lang = 'es') {
    this.translate.use(lang);
  }

}
