import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { TranslateService } from '@ngx-translate/core';
import { AuthService } from 'src/app/services/auth.service';
import { UserService } from 'src/app/services/user.service';
import { AccessModalService } from '../../access/access-modal.service';
import { LayoutService } from '../layout.service';

@Component({
  selector: 'app-sidebar',
  templateUrl: './sidebar.component.html',
  styleUrls: ['./sidebar.component.scss'],
})
export class SidebarComponent implements OnInit {
  constructor(
    public userService: UserService,
    public accessModalService: AccessModalService,
    private router: Router,
    private authService: AuthService,
    private layoutService: LayoutService,
    public translate: TranslateService
  ) {}

  ngOnInit(): void {}

  logout() {
    this.authService.logout();
    this.router.navigate(['/']);
  }

  changLang(lang = 'es') {
    this.translate.use(lang);
    this.layoutService.toggleSidebar(false);
  }
}
