import { Injectable } from '@angular/core';
import { TranslateService } from '@ngx-translate/core';
import { ActionType } from 'src/app/models/ActionType';
import Pet from 'src/app/models/Pet';

@Injectable({
  providedIn: 'root'
})
export class TitleGenerator {

  constructor(private translate: TranslateService) { }

  public generateTitle(pet: Pet) {
    switch (pet.lastState.type) {
      case ActionType.FOUND:
        return this.translate.instant('titleGenerator.found', {name: pet.name});
      case ActionType.LOST:
        return this.translate.instant('titleGenerator.lost', {name: pet.name});
      case ActionType.SIGHTING:
        return this.translate.instant('titleGenerator.sighting', {name: pet.name});
      default:
        throw new Error('Error, type not found');
    }
  }


}
