import { ChangeDetectionStrategy, Component, Input, OnInit } from '@angular/core';
import { TranslateModule, TranslateService } from '@ngx-translate/core';
import { DifferencePipe, TimeAgoPipe } from 'ngx-moment';
import { ActionsService } from 'src/app/content/actions/actions.service';
import Pet from 'src/app/models/Pet';
import { environment } from 'src/environments/environment';

interface SocialOptions {
  url: string;
  title: string;
  description: string;
  tags?: string;
  image?: string;
}

@Component({
  selector: 'app-pet-social',
  templateUrl: './pet-social.component.html',
  styleUrls: ['./pet-social.component.scss'],
  changeDetection: ChangeDetectionStrategy.OnPush
})
export class PetSocialComponent implements OnInit {

  @Input()
  pet: Pet;

  socialOpts: SocialOptions;

  constructor(private translate: TranslateService) { }

  stopPropagation(event: Event) {
    event.stopPropagation();
  }

  ngOnInit(): void {
    this.socialOpts = {
      url: `${environment.self_base_url}pet/${this.pet.id}`,
      title: this.translate.instant('social.title', { petName: this.pet.name}),
      description: this.translate.instant('social.descripcion', { petName: this.pet.name})
    }
  }

}
