import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { UserResolver } from 'src/app/resolvers/user.resolver';
import { SharedModule } from 'src/app/shared/shared.module';
import { UserDetailComponent } from './user-detail/user-detail.component';
import { UserPetsComponent } from './user-pets/user-pets.component';
import { UserPetItemComponent } from './user-pet-item/user-pet-item.component';
import { UserPetEditComponent } from './user-pet-edit/user-pet-edit.component';
import { PetResolver } from 'src/app/resolvers/pet.resolver';
import { IsOwnPetGuard } from 'src/app/guards/is-own-pet.guard';
import { UpdatePetFormComponent } from './user-pet-edit/update-pet-form/update-pet-form.component';
import { UpdatePetImagesComponent } from './user-pet-edit/update-pet-images/update-pet-images.component';

const routes: Routes = [
  { path: 'pets', component: UserPetsComponent },
  { path: 'pet/:id/edit', component: UserPetEditComponent, canActivate: [IsOwnPetGuard], resolve: {pet: PetResolver} },
  { path: '', pathMatch: 'full', component: UserDetailComponent, resolve: {user: UserResolver} }
];

@NgModule({
  imports: [RouterModule.forChild(routes), SharedModule, CommonModule],
  exports: [],
  declarations: [UserDetailComponent, UserPetsComponent, UserPetItemComponent, UserPetEditComponent, UpdatePetFormComponent, UpdatePetImagesComponent],
  providers: [],
})
export class UserModule {}
