import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, Router } from '@angular/router';
import { Observable, throwError } from 'rxjs';
import { catchError } from 'rxjs/operators';
import { PetService } from '../content/pet/pet.service';
import Pet from '../models/Pet';

@Injectable({ providedIn: 'root' })
export class PetResolver implements Resolve<Pet> {

  constructor(private petService: PetService, private router: Router) {}

  resolve(route: ActivatedRouteSnapshot): Observable<Pet> | Promise<Pet> | Pet {
    const id = route.params['id'];
    return this.petService.getPetDetail(id).pipe(catchError(err => {
      this.router.navigate(['/']);
      return throwError(err);
    }));
  }
}
