  import { Injectable } from '@angular/core';
import { TranslateService } from '@ngx-translate/core';
import { ActiveToast, ToastrService } from 'ngx-toastr';

@Injectable({
  providedIn: 'root'
})
export class NotificationService {

  constructor(private toastr: ToastrService, private translate: TranslateService) { }

  success(message = this.translate.instant('response.ok.def-message'), title = this.translate.instant('response.ok.def-title')): ActiveToast<any> {
    return this.toastr.success(message, title);
  }

  error(message = this.translate.instant('response.ko.def-message'), title = this.translate.instant('response.ko.def-title')): ActiveToast<any> {
    return this.toastr.error(message, title);
  }

  bottomWarnMessage(message, title = this.translate.instant('response.bottom.def-title')): ActiveToast<any> {
    return this.toastr.info(message, title, { positionClass: 'toast-bottom-full-width', timeOut: 7000, extendedTimeOut: 1000 });
  }

}
