import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root'
})
export class RestService {

  static API_ENDPOINT = environment.api_endpoint;

  constructor(private http: HttpClient) { }

  post(endpoint: string, body?: object): Observable<any> {
    return this.http.post(RestService.API_ENDPOINT + endpoint, body);
  }

  get(endpoint: string): Observable<any> {
    return this.http.get(RestService.API_ENDPOINT + endpoint);
  }

  put(endpoint: string, body?: object): Observable<any> {
    return this.http.put(RestService.API_ENDPOINT + endpoint, body);
  }

  patch(endpoint: string, body?: object): Observable<any> {
    return this.http.patch(RestService.API_ENDPOINT + endpoint, body);
  }

  delete(endpoint: string): Observable<any> {
    return this.http.delete(RestService.API_ENDPOINT + endpoint);
  }
}
