import { Component, OnDestroy, OnInit } from '@angular/core';
import { Subject } from 'rxjs';

/**
 * Base Components for PetFinder Components
 * ! No need to invoke super when extending
 */
@Component({
  selector: 'app-base',
  template: ``
})
export abstract class BaseComponent implements OnDestroy {

  protected destroy$: Subject<any>;

  constructor() {
    this.destroy$ = new Subject<void>();
  }

  ngOnDestroy() {
    this.destroy$.next();
    this.destroy$.complete();
  }

}
