import { Component, EventEmitter, Input, OnInit, Output } from '@angular/core';
import Page from 'src/app/models/Page';
import { PageParams } from 'src/app/models/PageParams';

@Component({
  selector: 'app-paginator',
  templateUrl: './paginator.component.html',
  styleUrls: ['./paginator.component.scss']
})
export class PaginatorComponent implements OnInit {

  @Input()
  page: Page<any>;

  @Output()
  paginate = new EventEmitter<PageParams>();

  constructor() { }

  ngOnInit(): void {
  }

  navigateToPage(page: number): void {
    this.paginate.emit({ page });
  }

}
