import { Component, Input, OnInit } from '@angular/core';

@Component({
  selector: 'app-spinner',
  template: `
  <div id="spinner-modal-id" *ngIf="visible">
    <div class="d-flex justify-content-center align-items-center h-100">
      <i class="fas fa-spinner fa-3x fa-spin text-brand"></i>
    </div>
  </div>
  `,
  styles: [`#spinner-modal-id {
    position: absolute;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
    z-index: 5000;
    opacity: 0.6;
    background-color: black;
  }`]
})
export class SpinnerComponent implements OnInit {

  @Input()
  visible = false;

  constructor() { }

  ngOnInit(): void {
  }

}
