import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { ModalModule } from 'ngx-bootstrap/modal';
import { BsDropdownModule } from 'ngx-bootstrap/dropdown';
import { BsDatepickerModule, BsLocaleService } from 'ngx-bootstrap/datepicker';
import { CarouselModule } from 'ngx-bootstrap/carousel';
import { esLocale } from 'ngx-bootstrap/locale';
import { defineLocale } from 'ngx-bootstrap/chronos';
import { TranslateService } from '@ngx-translate/core';

defineLocale('es', esLocale);

@NgModule({
  declarations: [],
  imports: [
    CommonModule,
    ModalModule.forRoot(),
    BsDropdownModule.forRoot(),
    BsDatepickerModule.forRoot(),
    CarouselModule.forRoot(),

  ],
  exports: [ModalModule, BsDropdownModule, BsDatepickerModule, CarouselModule]
})
export class NgxBootstrapModule {

  constructor(private bsLocaleService: BsLocaleService, private translate: TranslateService) {
    this.bsLocaleService.use(this.translate.currentLang);
    this.translate.onLangChange.subscribe((lang) => {
      this.bsLocaleService.use(lang.lang);
    });
  }
}
