import { Pipe, PipeTransform } from '@angular/core';
import { environment } from 'src/environments/environment';
import { Image } from '../../models/Image';

@Pipe({
  name: 'image'
})
export class ImagePipe implements PipeTransform {

  transform(image: Image, defaultImage = true): unknown {
    if ((!image || !image.systemFileName) && defaultImage) {
      return 'assets/images/no-image.svg';
    } else if (!image || !image.systemFileName) {
      throw new Error('Error building image url');
    }
    return `${environment.api_endpoint}/image/${image.systemFileName}`;
  }

}
