import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { NgxBootstrapModule } from './ngx-bootstrap.module';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { SpinnerComponent } from './components/spinner/spinner.component';
import { ToastrModule } from 'ngx-toastr';
import { NgxUploaderModule } from 'ngx-uploader';
import { ShareModule } from 'ngx-sharebuttons';
import { MomentModule } from 'ngx-moment';
import { LeafletModule } from '@asymmetrik/ngx-leaflet';
import { NgxMasonryModule } from 'ngx-masonry';
import { ImagePipe } from './pipes/image.pipe';
import { TranslateModule } from '@ngx-translate/core';
import { PaginatorComponent } from './components/paginator/paginator.component';

@NgModule({
  declarations: [SpinnerComponent, ImagePipe, PaginatorComponent],
  imports: [
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    ToastrModule.forRoot(),
    NgxMasonryModule,
    NgxBootstrapModule,
    ShareModule,
    NgxUploaderModule,
    MomentModule,
    LeafletModule,
    TranslateModule
  ],
  exports: [
    NgxBootstrapModule,
    FormsModule,
    ReactiveFormsModule,
    NgxMasonryModule,
    SpinnerComponent,
    ImagePipe,
    ToastrModule,
    NgxUploaderModule,
    ShareModule,
    MomentModule,
    LeafletModule,
    TranslateModule,
    PaginatorComponent
  ],
})
export class SharedModule {}
